(* Persistent and incremental congruence-closure data structure.

   This module implements a persistent and incremental congruence
   closure data structure, given modules for symbols and terms.

*)

module type S = sig
  type t

  exception Inconsistent

  val empty : t
  val normal_form :  Literal.t ->  Literal.t 
  val add : Literal.t -> t -> t
  val assume : Literal.t -> Formula.Set.t -> t -> t
  val query : Literal.t -> t -> bool
  val explain: Literal.t -> t -> Formula.Set.t
  val classof : t -> Term.t -> Term.t list
end

(*module CombineX (X1 : Sig.THEORY)(X2 : Sig.THEORY) : Sig.THEORY*)

module CombineX : Sig.THEORY

module Make (X : Sig.THEORY) : S
