type gsubst = { sbt : Term.subst ; gen : int }

module type X = sig
  type t

  val classof : t -> Term.t -> Term.t list
  val query : Literal.t -> t -> bool
end

module type S = sig
  type t
  type uf

  val empty : t
  val add : int -> Formula.t option -> Term.t -> t -> t 
  val matching : Formula.t -> Term.t list -> t -> uf ->  gsubst list
end

module Make (X : X) : S with type uf = X.t
