type binop = Plus | Minus | Mult | Div | Modulo
type t = 
    Name of Hstring.t
  | Int of Hstring.t
  | Binop of binop 
  | Var of Hstring.t

val name : string -> t
val var : string -> t
val int : string -> t
val real : string -> t
val unit : t 

val plus : t
val minus : t
val mult : t
val div : t
val modulo : t

val equal : t -> t -> bool
val compare : t -> t -> int
val hash : t -> int

val print : Format.formatter -> t -> unit

(*val is_const : t -> bool
val value : t -> int*)

val is_c : t -> bool
val is_ac : t -> bool
val dummy : t
val fresh : unit -> t
  
module Map : Map.S with type key = t
module Set : Set.S with type elt = t

